Index: emacs/src/nsselect.m
diff -c /dev/null emacs/src/nsselect.m:1.1
*** /dev/null	Fri Aug  2 21:07:53 1996
--- emacs/src/nsselect.m	Fri Jul 19 05:08:18 1996
***************
*** 0 ****
--- 1,421 ----
+ /* NS Selection processing for emacs
+    Copyright (C) 1993, 1994 Free Software Foundation.
+ 
+ This file is part of GNU Emacs.
+ 
+ GNU Emacs is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ GNU Emacs is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with GNU Emacs; see the file COPYING.  If not, write to
+ the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #import <appkit/appkit.h>
+ 
+ #include "config.h"
+ #include "lisp.h"
+ #include "nsterm.h"
+ #include "dispextern.h"
+ #include "frame.h"
+ #include "blockinput.h"
+ #include "termhooks.h"
+ #include "multi-frame.h"
+ 
+ #define CUT_BUFFER_SUPPORT
+ 
+ static NXAtom NXSecondaryPboard;
+ 
+ static NXAtom symbol_to_nx_atom (Lisp_Object sym)
+    {
+    CHECK_SYMBOL(sym,0);
+    if (EQ (sym, QPRIMARY))     return NXGeneralPboard;
+    if (EQ (sym, QSECONDARY))   return NXSecondaryPboard;
+    if (EQ (sym, QTEXT))        return NXAsciiPboardType;
+    return NXUniqueString(XSYMBOL(sym)->name->data);
+    }
+ 
+ static Lisp_Object nx_atom_to_symbol (NXAtom t)
+    {
+    if (t==NXGeneralPboard)         return QPRIMARY;
+    if (t==NXSecondaryPboard)       return QSECONDARY;
+    if (t==NXAsciiPboardType)       return QTEXT;
+    if (t==NXFilenamePboardType)    return QFILE_NAME;
+    if (t==NXTabularTextPboardType) return QTEXT;
+    return intern(t);
+    }
+ 
+ static Lisp_Object clean_local_selection_data (Lisp_Object obj)
+    {
+    if (CONSP (obj)
+        && INTEGERP (XCONS (obj)->car)
+        && CONSP (XCONS (obj)->cdr)
+        && INTEGERP (XCONS (XCONS (obj)->cdr)->car)
+        && NILP (XCONS (XCONS (obj)->cdr)->cdr))
+       obj = Fcons (XCONS (obj)->car, XCONS (obj)->cdr);
+ 
+    if (CONSP (obj)
+        && INTEGERP (XCONS (obj)->car)
+        && INTEGERP (XCONS (obj)->cdr))
+       {
+       if (XINT (XCONS (obj)->car) == 0)
+          return XCONS (obj)->cdr;
+       if (XINT (XCONS (obj)->car) == -1)
+          return make_number (- XINT (XCONS (obj)->cdr));
+       }
+ 
+    if (VECTORP (obj))
+       {
+       int i;
+       int size = XVECTOR (obj)->size;
+       Lisp_Object copy;
+ 
+       if (size == 1)
+          return clean_local_selection_data (XVECTOR (obj)->contents [0]);
+       copy = Fmake_vector (size, Qnil);
+       for (i = 0; i < size; i++)
+          XVECTOR (copy)->contents [i]
+             = clean_local_selection_data (XVECTOR (obj)->contents [i]);
+       return copy;
+       }
+ 
+    return obj;
+    }
+ 
+ Lisp_Object ns_string_from_pasteboard(id pb)
+    {
+    int i;
+    NXAtom type;
+    Lisp_Object ret;
+    int l;
+    char *d;
+ 
+    for (i=0;ns_return_types[i];i++);
+    type=[pb findAvailableTypeFrom:ns_return_types num:i];
+    if (type==0) return Qnil;
+    if (![pb readType:type data: &d length: &l])
+       Fsignal (Qerror, Fcons (build_string ("pasteboard doesn't contain valid data"), Qnil));
+    ret=make_string (d, l);
+    [pb deallocatePasteboardData: d length: l];
+    return ret;
+    }
+ 
+ void ns_declare_pasteboard(id pb)
+    {
+    int i;
+    for (i=0;ns_send_types[i];i++);
+    [pb declareTypes:ns_send_types num:i owner:NXApp];
+    }
+ 
+ void ns_undeclare_pasteboard(id pb)
+    {
+    const NXAtom types[] = { };
+    [pb declareTypes:types num:0 owner:nil];
+    }
+ 
+ void ns_string_to_pasteboard(id pb,Lisp_Object str)
+    {
+    int i;
+ 
+    if (EQ (str, Qnil))
+       {
+       const NXAtom types[] = { };
+       [pb declareTypes:types num:0 owner:nil];
+       }
+    else
+       {
+       CHECK_STRING(str, 0);
+       for (i=0;ns_send_types[i];i++);
+       [pb declareTypes:ns_send_types num:i owner:nil];
+       for (i--;i>=0;i--)
+          [pb writeType:ns_send_types[i]
+                   data:XSTRING(str)->data length:XSTRING(str)->size];
+       }
+    }
+ 
+ static Lisp_Object ns_get_local_selection(Lisp_Object selection_name,
+                                           Lisp_Object target_type)
+    {
+    Lisp_Object local_value;
+    Lisp_Object handler_fn, value, type, check;
+    int count;
+ 
+    local_value = assq_no_quit (selection_name, Vselection_alist);
+ 
+    if (NILP (local_value)) return Qnil;
+ 
+    count = specpdl_ptr - specpdl;
+    specbind (Qinhibit_quit, Qt);
+    CHECK_SYMBOL (target_type, 0);
+    handler_fn = Fcdr (Fassq (target_type, Vselection_converter_alist));
+    if (!NILP (handler_fn))
+       value=call3(handler_fn, selection_name, target_type,
+                   XCONS (XCONS (local_value)->cdr)->car);
+    else
+       value=Qnil;
+    unbind_to (count, Qnil);
+ 
+    check=value;
+    if (CONSP(value) && SYMBOLP(XCONS (value)->car))
+       {
+       type=XCONS(value)->car;
+       check=XCONS(value)->cdr;
+       }
+ 
+    if (STRINGP (check) || VECTORP (check) || SYMBOLP (check)
+        || INTEGERP (check) || NILP (value))
+       return value;
+ 
+    if (CONSP (check)
+        && INTEGERP (XCONS (check)->car)
+        && (INTEGERP (XCONS (check)->cdr)||
+            (CONSP (XCONS (check)->cdr)
+             && INTEGERP (XCONS (XCONS (check)->cdr)->car)
+             && NILP (XCONS (XCONS (check)->cdr)->cdr))))
+       return value;
+ 
+    return Fsignal (Qerror,
+                    Fcons (build_string ("invalid data returned by selection-conversion function"),
+                           Fcons (handler_fn, Fcons (value, Qnil))));
+    }
+ 
+ static Lisp_Object ns_get_foreign_selection(Lisp_Object symbol, Lisp_Object target)
+    {
+    id pb;
+    pb=[Pasteboard newName:symbol_to_nx_atom(symbol)];
+    return ns_string_from_pasteboard(pb);
+    }
+ 
+ void ns_handle_selection_request(struct input_event *event)
+    {
+    id pb=(id)event->x;
+    NXAtom type=(NXAtom)event->y;
+    Lisp_Object selection_name,selection_data,target_symbol,data;
+    Lisp_Object successful_p,rest;
+ 
+    selection_name=nx_atom_to_symbol([pb name]);
+    target_symbol=nx_atom_to_symbol(type);
+    selection_data= assq_no_quit (selection_name, Vselection_alist);
+    successful_p=Qnil;
+ 
+    if (NILP (selection_data)) goto DONE;
+ 
+    data = ns_get_local_selection (selection_name, target_symbol);
+    if (!NILP(data))
+       {
+       if (STRINGP(data))
+          [pb writeType:type data:XSTRING(data)->data length:XSTRING(data)->size];
+       successful_p=Qt;
+       }
+ 
+  DONE:
+    if (!EQ(Vsent_selection_hooks,Qunbound))
+       {
+       for(rest=Vsent_selection_hooks;CONSP(rest); rest=Fcdr(rest))
+          call3 (Fcar(rest), selection_name, target_symbol, successful_p);
+       }
+    }
+ 
+ void ns_handle_selection_clear(struct input_event *event)
+    {
+    id pb=(id)event->x;
+    Lisp_Object selection_name,selection_data,rest;
+ 
+    selection_name=nx_atom_to_symbol([pb name]);
+    selection_data=assq_no_quit (selection_name, Vselection_alist);
+    if (NILP(selection_data)) return;
+ 
+    if (EQ (selection_data, Fcar (Vselection_alist)))
+      Vselection_alist = Fcdr (Vselection_alist);
+    else
+       {
+       for (rest = Vselection_alist; !NILP (rest); rest = Fcdr (rest))
+          if (EQ (selection_data, Fcar (Fcdr (rest))))
+ 	    Fsetcdr(rest,Fcdr(Fcdr(rest)));
+       }
+ 
+    if (!EQ(Vlost_selection_hooks,Qunbound))
+       {
+       for(rest=Vlost_selection_hooks;CONSP(rest); rest=Fcdr(rest))
+          call1 (Fcar(rest), selection_name);
+       }
+    }
+ 
+ DEFUN ("ns-own-selection-internal", Fns_own_selection_internal,
+        Sns_own_selection_internal, 2, 2, 0, "Assert a selection.\n\
+ For more details see the window system specific function.")
+   (selection_name, selection_value)
+ Lisp_Object selection_name,selection_value;
+    {
+    id pb;
+    Lisp_Object old_value, new_value;
+ 
+    check_ns();
+    CHECK_SYMBOL (selection_name, 0);
+    if (NILP (selection_value)) error ("selection-value may not be nil.");
+    pb=[Pasteboard newName:symbol_to_nx_atom(selection_name)];
+    ns_declare_pasteboard(pb);
+    old_value=assq_no_quit (selection_name, Vselection_alist);
+    new_value= Fcons(selection_name, Fcons(selection_value, Qnil));
+    if (NILP(old_value))
+       Vselection_alist=Fcons(new_value,Vselection_alist);
+    else
+       Fsetcdr(old_value,Fcdr(new_value));
+    /* XXX An evil hack, but a necessary one I fear XXX */
+       {
+       struct input_event ev;
+       ev.kind=selection_request_event;
+       ev.modifiers=0;
+       ev.code=0;
+       ev.x=(int)pb;
+       ev.y=(int)NXAsciiPboardType;
+       ns_handle_selection_request(&ev);
+       }
+    return selection_value;
+    }
+ 
+ DEFUN ("ns-disown-selection-internal", Fns_disown_selection_internal,
+        Sns_disown_selection_internal, 1, 2, 0,
+        "If we own the selection SELECTION, disown it.")
+   (selection_name, time)
+ Lisp_Object selection_name,time;
+    {
+    id pb;
+    check_ns();
+    CHECK_SYMBOL (selection_name, 0);
+    if (NILP(assq_no_quit (selection_name, Vselection_alist))) return Qnil;
+ 
+    pb=[Pasteboard newName:symbol_to_nx_atom(selection_name)];
+    ns_undeclare_pasteboard(pb);
+    return Qt;
+    }
+ 
+ DEFUN ("ns-selection-exists-p", Fns_selection_exists_p, Sns_selection_exists_p,
+        0, 1, 0, "Whether there is an owner for the given selection.\n\
+ The arg should be the name of the selection in question, typically one of\n\
+ the symbols `PRIMARY', `SECONDARY', or `CLIPBOARD'.\n\
+ \(Those are literal upper-case symbol names.)\n\
+ For convenience, the symbol nil is the same as `PRIMARY',\n\
+ and t is the same as `SECONDARY'.)")
+   (selection)
+ Lisp_Object selection;
+    {
+    id pb;
+    const NXAtom *types;
+ 
+    check_ns();
+    CHECK_SYMBOL (selection, 0);
+    if (EQ (selection, Qnil)) selection = QPRIMARY;
+    if (EQ (selection, Qt)) selection = QSECONDARY;
+    pb=[Pasteboard newName:symbol_to_nx_atom(selection)];
+    types=[pb types];
+    return (*types==0) ? Qnil : Qt;
+    }
+ 
+ DEFUN ("ns-selection-owner-p", Fns_selection_owner_p, Sns_selection_owner_p,
+        0, 1, 0,
+   "Whether the current Emacs process owns the given selection.\n\
+ The arg should be the name of the selection in question, typically one of\n\
+ the symbols `PRIMARY', `SECONDARY', or `CLIPBOARD'.\n\
+ \(Those are literal upper-case symbol names.)\n\
+ For convenience, the symbol nil is the same as `PRIMARY',\n\
+ and t is the same as `SECONDARY'.)")
+   (selection)
+ Lisp_Object selection;
+    {
+    check_ns();
+    CHECK_SYMBOL (selection, 0);
+    if (EQ (selection, Qnil)) selection = QPRIMARY;
+    if (EQ (selection, Qt)) selection = QSECONDARY;
+    return (NILP (Fassq (selection, Vselection_alist))) ? Qnil : Qt;
+    }
+ 
+ DEFUN ("ns-get-selection-internal", Fns_get_selection_internal,
+        Sns_get_selection_internal, 2, 2, 0,
+   "Return text selected from some pasteboard.\n\
+ SELECTION is a symbol, typically `PRIMARY', `SECONDARY', or `CLIPBOARD'.\n\
+ \(Those are literal upper-case symbol names.)\n\
+ TYPE is the type of data desired, typically `STRING'.")
+   (selection_name, target_type)
+ Lisp_Object selection_name, target_type;
+    {
+    Lisp_Object val;
+ 
+    check_ns();
+    CHECK_SYMBOL(selection_name, 0);
+    CHECK_SYMBOL(target_type,0);
+    val= ns_get_local_selection(selection_name,target_type);
+    if (NILP(val))
+       val= ns_get_foreign_selection(selection_name,target_type);
+    if (CONSP(val) && SYMBOLP (Fcar(val)))
+       {
+       val = Fcdr(val);
+       if (CONSP (val) && NILP (Fcdr(val)))
+          val = Fcar(val);
+       }
+    val = clean_local_selection_data (val);
+    return val;
+    }
+ 
+ #ifdef CUT_BUFFER_SUPPORT
+ DEFUN ("ns-get-cut-buffer-internal", Fns_get_cut_buffer_internal,
+        Sns_get_cut_buffer_internal, 1, 1, 0,
+   "Returns the value of the named cut buffer.")
+   (buffer)
+ Lisp_Object buffer;
+    {
+    id pb;
+    check_ns();
+    pb=[Pasteboard newName:symbol_to_nx_atom(buffer)];
+    return ns_string_from_pasteboard(pb);
+    }
+ 
+ DEFUN ("ns-rotate-cut-buffers-internal", Fns_rotate_cut_buffers_internal,
+        Sns_rotate_cut_buffers_internal, 1, 1, 0,
+    "Rotate the values of the cut buffers by the given number of steps;\n\
+  positive means move values forward, negative means backward.")
+   (n)
+      Lisp_Object n;
+    {
+    /* XXX This function is unimplemented under NeXTstep XXX */
+    return Qnil;
+    }
+ 
+ DEFUN ("ns-store-cut-buffer-internal", Fns_store_cut_buffer_internal,
+        Sns_store_cut_buffer_internal, 2, 2, 0,
+   "Sets the value of the named cut buffer (typically CUT_BUFFER0).")
+   (buffer, string)
+ Lisp_Object buffer, string;
+    {
+    id pb;
+    check_ns();
+    pb=[Pasteboard newName:symbol_to_nx_atom(buffer)];
+    ns_string_to_pasteboard(pb,string);
+    return Qnil;
+    }
+ #endif
+ 
+ void nxatoms_of_nsselect (void)
+    {
+    NXSecondaryPboard=NXUniqueString("NeXT secondary pasteboard name");
+    }
+ 
+ void syms_of_nsselect (void)
+    {
+    defsubr (&Sns_disown_selection_internal);
+    defsubr (&Sns_get_selection_internal);
+    defsubr (&Sns_own_selection_internal);
+    defsubr (&Sns_selection_exists_p);
+    defsubr (&Sns_selection_owner_p);
+ #ifdef CUT_BUFFER_SUPPORT
+    defsubr (&Sns_get_cut_buffer_internal);
+    defsubr (&Sns_rotate_cut_buffers_internal);
+    defsubr (&Sns_store_cut_buffer_internal);
+ #endif
+    }
Index: emacs/src/nsterm.h
diff -c /dev/null emacs/src/nsterm.h:1.4
*** /dev/null	Fri Aug  2 21:08:00 1996
--- emacs/src/nsterm.h	Fri Aug  2 04:02:34 1996
***************
*** 0 ****
--- 1,519 ----
+ /* Definitions and headers for communication with NeXTstep
+    Copyright (C) 1989, 1993 Free Software Foundation, Inc.
+ 
+ This file is part of GNU Emacs.
+ 
+ GNU Emacs is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+ 
+ GNU Emacs is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ GNU General Public License for more details.
+ 
+ You should have received a copy of the GNU General Public License
+ along with GNU Emacs; see the file COPYING.  If not, write to
+ the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */
+ 
+ #include "config.h"
+ 
+ #ifdef HAVE_NS
+ 
+ #ifdef __OBJC__
+ #import <appkit/appkit.h>
+ #import <remote/NXProxy.h>
+ 
+ @interface Menu (UndocumentedMenu)
+ - (void)_restoreInitialMenuPos;
+ - (void)_saveInitialMenuPos;
+ @end
+ 
+ @interface SavePanel (UndocumentedSavePanel)
+ - (BOOL)_validateNames:(char *)name checkBrowser:(BOOL)check;
+ @end
+ 
+ /* These two interfaces were ruthlessly stolen from John C. Randolph */
+ @interface View (windowButtons)
+ - _setMask:(unsigned int) mask;
+ @end
+ 
+ @interface Window (windowButtons)
+ - toggleClose:sender;
+ - toggleMiniaturize:sender;
+ - setCloseButton:sender to:(BOOL)bool;
+ - setMiniaturizeButton:sender to:(BOOL)bool;
+ - showCloseButton:sender;
+ - showMiniaturizeButton:sender;
+ - hideCloseButton:sender;
+ - hideMiniaturizeButton:sender;
+ - updateBorder;
+ @end
+ 
+ @protocol Interrupt
+ -(oneway void)interrupt;
+ @end
+ 
+ @protocol BaseValueGetting
+ -(int)numSubValues;
+ -(id <BaseValueGetting>)subValueAt:(int)nValue;
+ -(id <BaseValueGetting>)subValueAt:(int)nValue withFlags:(out unsigned *)pFlags andName:(out char **)pName;
+ -(id <BaseValueGetting>)subValueNamed:(in char *)valueName index:(out int *)index;
+ -(id <BaseValueGetting>)subValueFor:(id <BaseValueGetting>)value from:(int *)from index:(int *)index;
+ @end
+ 
+ @protocol Value <BaseValueGetting>
+ -(char *)valueName;
+ -(unsigned)size;
+ -(unsigned)scalerValueFrom:(unsigned)from;
+ -(float)floatValueFrom:(unsigned)from;
+ -(char *)enumValueFrom:(unsigned)from;
+ -(char *)stringValueFrom:(unsigned)from;
+ -(char *)functionValueFrom:(unsigned)from;
+ -(unsigned)addressFrom:(unsigned)from;
+ -(unsigned)addressFrom:(unsigned)from isValid:(out int *)isValid;
+ -(unsigned)flags;
+ -(char *)typeName;
+ -(int)castToTypeNamed:(in char *)typeName from:(unsigned)from;
+ @end
+ 
+ @protocol Frame <BaseValueGetting>
+ -(int)hasSymbols;
+ -(char *)functionName;
+ -(char *)functionNameAndHasSymbols:(int *)hasSymbols;
+ -(unsigned)frame;
+ -(unsigned)pc;
+ -(char *)fileNameAndLine:(unsigned *)line;
+ -(int)frameNumber;
+ @end
+ 
+ @protocol Breakpoint
+ -(char *)fileName;
+ -(int)line;
+ -(BOOL)enabled;
+ -(char *)commands;
+ -(char *)condition;
+ -(char *)expression;
+ -(char *)function;
+ @end
+ 
+ @protocol GdbController
+ -(oneway void)breakInFile:(in char *)filename atLine:(int)line;
+ -(oneway void)untilInFile:(in char *)filename atLine:(int)line;
+ -(oneway void)step;
+ -(oneway void)next;
+ -(oneway void)continue;
+ -(oneway void)up;
+ -(oneway void)frame;
+ -(oneway void)down;
+ -(oneway void)finish;
+ -(oneway void)run;
+ -(oneway void)quit;
+ -(oneway void)printExpression:(in char *)selection;
+ -(oneway void)printExpressionIndirect:(in char *)selection;
+ -(oneway void)selectFrame:(int)frame;
+ -(oneway void)interrupt;
+ -(int)getFramesUpTo:(int)maxFrames selectedFrame:(out int *)sel symbolsOnly:(BOOL)sOnly;
+ -(id <Frame>)frameAt:(int)frameIndex functionName:(out char **)pFunctionName from:(out unsigned int *)pFrom;
+ -(id <Frame>)frameAt:(int)frameIndex from:(out unsigned int *)pFrom;
+ -(id <Frame>)frameAt:(int)frameIndex;
+ -(char *)functionNameAt:(int)frameIndex;
+ -(char *)functionNameAt:(int)frameIndex hasSymbols:(int *)hasSymbols;
+ -(oneway void)errorOpeningFile:(char *)filename fromLine:(int)start to:(int)end;
+ -(oneway void)executeCommand:(char *)command;
+ -(oneway void)setClient:anObject;
+ -(oneway void)addSourceDirectory:(const char *)directory;
+ -(int)numBreakpoints;
+ -(id <Breakpoint>)breakpointAt:(int)index;
+ -(NXData *)completionsForPrefix:(const char *)prefix;
+ @end
+ 
+ @protocol GdbUser
+ -(oneway void)openFile:(char *)fileName onHost:(char *)hostName atTrueLine:(int)line;
+ -(oneway void)openFile:(char *)fileName onHost:(char *)hostName fromTrueLine:(int)startLine to:(int)endLine;
+ -(oneway void)setInterruptHandler:handler;
+ -(oneway void)disconnect;
+ -(oneway void)frameChanged;
+ -(oneway void)programIsRunning;
+ -(oneway void)programStopped;
+ -(oneway void)programIsDead;
+ -(oneway void)setController:(id <GdbController>)anObject;
+ -(int)isNewUser;
+ -(oneway void)setGdbName:(const char *)theName;
+ @end
+ 
+ @protocol GdbNewUser
+ -(oneway void)openFile:(char *)fileName onHost:(char *)hostName atTrueLine:(int)line;
+ -(oneway void)openFile:(char *)fileName onHost:(char *)hostName fromTrueLine:(int)startLine to:(int)endLine;
+ -(oneway void)setInterruptHandler:handler;
+ -(oneway void)disconnect;
+ -(oneway void)frameChanged:(int)selectedFrame;
+ -(oneway void)programIsRunning;
+ -(oneway void)programStopped;
+ -(oneway void)programIsDead;
+ -(oneway void)setController:(id <GdbController>)anObject;
+ -(oneway void)programIsLoaded;
+ -(BOOL)isNewUser;
+ //-(oneway void)breakpointAdded:(id <Breakpoint>)breakpoint;
+ //-(oneway void)breakpointDeleted:(id <Breakpoint>)breakpoint;
+ //-(oneway void)breakpointChanged:(id <Breakpoint>)breakpoint;
+ @end
+ 
+ #define ISPOINTER   (1 << 0)
+ #define ISENUM      (1 << 1)
+ #define ISSCALER    (1 << 2)
+ #define ISFLOAT     (1 << 3)
+ #define ISDOUBLE    (1 << 4)
+ #define ISAGGREGATE (1 << 5)
+ #define ISCHAR	    (1 << 6)
+ #define ISARRAY     (1 << 7)
+ #define ISSIGNED    (1 << 8)
+ #define ISOBJECT    (1 << 9)
+ #define ISSTRING    (1 << 10)
+ #define ISFUNC      (1 << 11)
+ 
+ @protocol PBUser
+ -(oneway void)openFile:(char *)fileName onHost:(char *)hostName atTrueLine:(int)line;
+ -(oneway void)openFile:(char *)fileName onHost:(char *)hostName fromTrueLine:(int)startLine to:(int)endLine;
+ @end
+ 
+ @interface EmacsListener:Listener <PBUser, GdbNewUser>
+    {
+    }
+ @end
+ 
+ @interface EmacsApp :Application
+    {
+    id emacsListener;
+    }
+ 
+ -(int)openFile:(char *)fileName onHost:(char *)hostName atTrueLine:(int)line;
+ -(int)openFile:(char *)fileName onHost:(char *)hostName fromTrueLine:(int)startLine to:(int)endLine;
+ -(int)app:sender openFile:(const char *) filename type:(const char *) aType;
+ -(int)app:sender openTempFile:(const char *) filename type:(const char *) aType;
+ -(BOOL)appAcceptsAnotherFile:sender;
+ 
+ -appWillInit:sender;
+ -appDidInit:sender;
+ -applicationDefined:(NXEvent *) e;
+ 
+ -menuDown:sender;
+ 
+ #if 0
+ -pasteboardChangedOwner:sender;
+ -pasteboard:sender provideData:(NXAtom)type;
+ #endif
+ @end
+ 
+ @interface EmacsView :View
+    {
+    struct frame *emacsframe;
+    char *old_title;
+    }
+ 
+ - changeFont:sender;
+ - (BOOL) acceptsFirstResponder;
+ - becomeFirstResponder;
+ - resignFirstResponder;
+ 
+ - keyDown:(NXEvent *)theEvent;
+ - mouseDown:(NXEvent *)theEvent;
+ - mouseUp:(NXEvent *)theEvent;
+ - rightMouseDown:(NXEvent *)theEvent;
+ - rightMouseUp:(NXEvent *)theEvent;
+ - mouseEntered:(NXEvent *)theEvent;
+ - mouseExited:(NXEvent *)theEvent;
+ - menuDown:sender;
+ 
+ - windowDidResize:sender;
+ - windowWillResize:sender toSize:(NXSize *)frameSize;
+ - windowWillClose:sender;
+ - windowWillMiniaturize:sender toMiniwindow:miniwindow;
+ 
+ - windowDidMove:sender;
+ - windowDidDeminiaturize:sender;
+ - windowDidExpose:sender;
+ - windowDidMiniaturize:sender;
+ - windowDidBecomeKey:sender;
+ - windowDidResignKey:sender;
+ 
+ - drawSelf:(const NXRect *)rects :(int)rectCount;
+ - initFrameFromEmacs:(struct frame *)f;
+ 
+ - validRequestorForSendType:(NXAtom)typeSent andReturnType:(NXAtom)typeReturned;
+ 
+ /* Implemented NXDraggingDestination protocol methods.  */
+ -(NXDragOperation) draggingEntered:(id <NXDraggingInfo>) sender;
+ -(BOOL)performDragOperation:(id <NXDraggingInfo>) sender;
+ @end
+ 
+ @interface EmacsMenu :Menu
+    {
+    int minmarked;
+    id supercell;
+    BOOL wasVisible;
+    }
+ 
+ - initTitle:(const char *)aTitle;
+ - addItem:(Lisp_Object)val string:(Lisp_Object)aString bind:(Lisp_Object)bind;
+ 
+ - adjustMap:(Lisp_Object)keymap;
+ - adjustKey:(Lisp_Object)key binding:(Lisp_Object)bind;
+ - adjustKey:(Lisp_Object)key binding:(Lisp_Object)bind string:(Lisp_Object)string;
+ - findCell:(Lisp_Object)value;
+ - (int)findCellNumber:(Lisp_Object)value;
+ - transferCell:(int) row to:newmenu;
+ 
+ - addCell:cell;
+ - removeCell:cell;
+ 
+ - supercell;
+ - setSupercell:(id) nsupercell;
+ 
+ - mark;
+ - freeMarked;
+ 
+ - swapin;
+ - swapout;
+ @end
+ 
+ @interface EmacsMenuCell:MenuCell
+    {
+    Lisp_Object value;
+    id supercell;
+    }
+ 
+ - initTextCell:(const char *)aString;
+ - free;
+ 
+ - (Lisp_Object)value;
+ - setValue:(Lisp_Object)nvalue;
+ - supercell;
+ - setSupercell:(id) nsupercell;
+ @end
+ 
+ #if 1
+ // this is from 4.1
+ @interface EmacsMenuCard : Button
+    {
+    PopUpList *popup;
+    }
+ -init;
+ -addTitle: (char *)name;
+ -addItem:  (char *)name value:(Lisp_Object)val enabled:(BOOL)enabled;
+ @end
+ 
+ @interface EmacsMenuPanel: Panel
+    {
+    id list;
+    int maxwidth;
+    }
+ - initFromMenu:(Lisp_Object)menu;
+ - addItem:(char *)str value:(Lisp_Object)val enabled:(BOOL)enabled at:(int)pane;
+ - addTitle:(char *)str to:(int)pane;
+ - (int)cards;
+ - (Lisp_Object)runMenuAt:(NXCoord)x:(NXCoord)y;
+ @end
+ #else
+ // this is from 4.1.2
+ @interface EmacsPopupMenu:EmacsMenu
+    {
+    }
+ - windowWillClose:sender;
+ - menuFromKeymap:sender;
+ - menuFromList:sender;
+ - addItem:(Lisp_Object)val string:(Lisp_Object)aString bind:(Lisp_Object)bind;
+ - initFromMenu:(Lisp_Object)def;
+ - (Lisp_Object)runMenuAt:(NXCoord)x:(NXCoord)y;
+ @end
+ #endif
+ 
+ @interface EmacsDialogPanel:Panel
+    {
+    id command;
+    id title;
+    id matrix;
+    int rows,cols;
+    }
+ - initFromContents:(Lisp_Object)menu;
+ - addButton:(char *)str value:(Lisp_Object)val row:(int)row;
+ - addString:(char *)str row:(int)row;
+ - addSplit;
+ - (Lisp_Object)runDialogAt:(NXCoord)x:(NXCoord)y;
+ @end
+ 
+ @interface EmacsFilePanel:SavePanel
+   {
+   BOOL allowCreate,allowOld,allowDir;
+   }
+ - setAllowCreate:(BOOL)ifAllowCreate;
+ - setAllowOld:(BOOL)ifAllowOld;
+ - setAllowDir:(BOOL)ifAllowDir;
+ @end
+ 
+ @interface EmacsScroller:Scroller
+    {
+    Lisp_Object win;
+    BOOL condemned;
+    }
+ - initFrame:(const NXRect *)r window:(Lisp_Object)win;
+ - setFrame:(const NXRect *)r;
+ - free;
+ 
+ - scrollerMoved:sender;
+ - setPosition:(int) position portion:(int) portion whole:(int) whole;
+ 
+ - condemn;
+ - reprieve;
+ - judge;
+ @end
+ 
+ extern id ns_current_display;
+ extern id ns_emacscolors;
+ extern id <Interrupt> ns_gdb_interrupt_controller;
+ extern id <GdbController> ns_gdb_controller;
+ extern int ns_use_open_panel;
+ extern int ns_use_yes_no_panel;
+ extern int ns_gdb_frame;
+ extern Lisp_Object ns_alternate_is_meta,ns_iso_latin,ns_cursor_blink_rate;
+ extern Lisp_Object ns_shrink_space;
+ extern Lisp_Object ns_gdb_status;
+ extern Lisp_Object ns_menu_path;
+ extern unsigned char *ns2isomap;
+ extern unsigned char *iso2nsmap;
+ extern NXAtom *ns_send_types,*ns_return_types;
+ extern struct frame *ns_highlight_frame;
+ extern struct frame *ns_focus_frame;
+ extern struct frame *ns_focus_event_frame;
+ #endif
+ 
+ enum ns_highlight_kinds
+    {
+    no_highlight=0,
+    filled_box,
+    hollow_box,
+    bar,
+    line
+    };
+ 
+ struct ns_display
+    {
+ #ifdef __OBJC__
+    id view;
+    id miniimage;
+    NXColor current_cursor_color;
+    NXColor desired_cursor_color;
+ #else
+    void *view;
+    void *miniimage;
+    char current_cursor_color[16];
+    char desired_cursor_color[16];
+ #endif
+    struct ns_face *face;
+    float top;
+    float left;
+    int line_height;
+    float internal_border_width;
+    float border_width, border_height;
+    enum ns_highlight_kinds current_cursor, desired_cursor;
+ 
+    /* Table of parameter faces for this frame.  Any NS resources (pixel
+       values, fonts) referred to here have been allocated explicitly
+       for this face, and should be freed if we change the face.  */
+    struct ns_face **param_faces;
+    int n_param_faces;
+ 
+    /* Table of computed faces for this frame.  These are the faces
+       whose indexes go into the upper bits of a glyph, computed by
+       combining the parameter faces specified by overlays, text
+       properties, and what have you.  The NS resources mentioned here
+       are all shared with parameter faces.  */
+    struct ns_face **computed_faces;
+    int n_computed_faces;                /* How many are valid */
+    int size_computed_faces;     /* How many are allocated */
+    };
+ 
+ /* FIXME/cl */
+ #define NS_PIXEL_WIDTH(f) ((f)->display.ns->pixel_width)
+ #define NS_PIXEL_HEIGHT(f) (ns_pixel_height (f))
+ 
+ struct ns_face
+    {
+    float width;
+    float height;
+    float descender;
+    float underpos;
+    float underwidth;
+    float size;
+    char underline;
+ #ifdef __OBJC__
+    NXAtom name;
+    id font;
+    NXColor foreground_color;
+    NXColor background_color;
+ #else
+    const char *name;
+    void *font;
+    char foreground_color[16];
+    char background_color[16];
+ #endif
+    };
+ 
+ extern int ns_new_font(), ns_load_font();
+ extern void check_ns(void);
+ extern void ns_set_frame_parameters();
+ extern void ns_display_menu_bar();
+ extern Lisp_Object ns_string_from_pasteboard();
+ extern void ns_string_to_pasteboard();
+ extern int ns_lisp_to_cursor_type();
+ extern struct frame *ns_focus_frame;
+ 
+ /* Create the first two computed faces for a frame -- the ones that
+    have GC's.  */
+ extern void ns_init_frame_faces (/* FRAME_PTR */);
+ 
+ /* Free the resources for the faces associated with a frame.  */
+ extern void ns_free_frame_faces (/* FRAME_PTR */);
+ 
+ /* Given a frame and a face name, return the face's ID number, or
+    zero if it isn't a recognized face name.  */
+ extern int ns_face_name_id_number (/* FRAME_PTR, Lisp_Object */);
+ 
+ /* Return non-zero if FONT1 and FONT2 have the same size bounding box.
+    We assume that they're both character-cell fonts.  */
+ extern int same_size_fonts (/* XFontStruct *, XFontStruct * */);
+ 
+ /* Recompute the GC's for the default and modeline faces.
+    We call this after changing frame parameters on which those GC's
+    depend.  */
+ extern void ns_recompute_basic_faces (/* FRAME_PTR */);
+ 
+ /* Return the face ID associated with a buffer position POS.  Store
+    into *ENDPTR the next position at which a different face is
+    needed.  This does not take account of glyphs that specify their
+    own face codes.  F is the frame in use for display, and W is a
+    window displaying the current buffer.
+ 
+    REGION_BEG, REGION_END delimit the region, so it can be highlighted.  */
+ extern int ns_compute_char_face (/* FRAME_PTR frame,
+                                     struct window *w,
+                                     int pos,
+                                     int region_beg, int region_end,
+                                     int *endptr */);
+ /* Return the face ID to use to display a special glyph which selects
+    FACE_CODE as the face ID, assuming that ordinarily the face would
+    be BASIC_FACE.  F is the frame.  */
+ extern int ns_compute_glyph_face (/* FRAME_PTR, int */);
+ 
+ #define BEANS 0xfabacaea
+ #define MINWIDTH 10
+ #define MINHEIGHT 10
+ 
+ #ifdef __OBJC__
+ #define XNS_SCROLL_BAR(vec) ((id) LISP_TO_VOID (vec))
+ #else
+ #define XNS_SCROLL_BAR(vec) LISP_TO_VOID (vec)
+ #endif
+ 
+ #endif
